Bug 444621 - RFE: list symbols in DT_HASH ad DT_GNU_HASH tables
RFE: list symbols in DT_HASH ad DT_GNU_HASH tables
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: elfutils (Show other bugs)
rawhide
All Linux
low Severity low
: ---
: ---
Assigned To: Marek Polacek
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-04-29 11:57 EDT by John Reiser
Modified: 2011-04-15 03:47 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description John Reiser 2008-04-29 11:57:05 EDT
Description of problem: There is no way to inspect which symbols appear in the
DT_HASH or DT_GNU_HASH tables.  This makes it more difficult than necessary to
document or debug problems involving runtime dynamic symbol lookup.


Version-Release number of selected component (if applicable):
elfutils-0.133-3.fc9.i386


How reproducible: always


Steps to Reproduce:
1. eu-readelf --all /bin/date
2.
3.
  
Actual results: does not contain any list or designation for which symbols
appear in the DT_HASH or DT_GNU_HASH tables.  


Expected results: some method to identify which symbols appear in DT_HASH and
DT_GNU_HASH tables.


Additional info:
Comment 1 Roland McGrath 2008-04-29 17:48:19 EDT
binutils readelf has the -D option, e.g. -D -s

Would the same feature in eu-readelf meet the need?
Comment 2 John Reiser 2008-04-29 19:58:44 EDT
I'd like an "independent" confirmation about which symbols are pointed to by the
DT_GNU_HASH table.  binutils "readelf -D -s" claims to list what is in the
ElfXX_Section .gnu.hash, which is not necessarily the same as what is in the
DT_GNU_HASH table.  Perhaps it is expected and/or intended that .gnu.hash
correspond to DT_GNU_HASH, but I'm worried about bugs.
Comment 3 Roland McGrath 2008-04-29 21:36:58 EDT
It may not be documented clearly, but the actual implementation of -D in
binutils readelf uses PT_DYNAMIC->DT_* for DT_{GNU_,}HASH, DT_SYMTAB, DT_RELA,
etc., rather than going from section headers as normal  An eu-readelf -D would
do the same.
Comment 4 John Reiser 2008-04-30 09:54:48 EDT
Generating the output using PT_DYNAMIC->DT_* for DT_{GNU_,}HASH, DT_SYMTAB, etc.
is fine.  What is not OK is using any ElfXX_Section info, except possibly as a
comment such as "DT_SYMTAB matches {.gnu.hash}.sh_offset".

Note You need to log in before you can comment on or make changes to this bug.